#ifndef C99_H
#define C99_H

#define	logtxt	"* c99 v4.0 (c) 1985, 1987 Clint Pulley [Win32 PC Version]"

#define	FOPEN	tifopen
#define	FCLOSE	tifclose
#define	PUTCHAR	tiputchar
#define	PUTC	tiputc
#define	PUTS	tiputs

#ifndef BOOL
	#define BOOL short
#endif

#ifndef TRUE
	#define TRUE	1
#endif

#ifndef FALSE
	#define FALSE	0
#endif

/* symbol table parameters
**
** This version has symtab space for
**    - 256 global symbols  (must be 2^n)
**    - 40  local symbols
*/
#define	SYMSIZ   13		/*	Symbol-table element size	*/
#define	GSYMSZ   256 * SYMSIZ	/*	Global symbol-table size	*/
#define	LSYMSZ   40 * SYMSIZ	/*	Local symbol-table size	*/
#define	GHSHMSK  255	/*	global symtab hash mask		*/

#ifdef	C99_MAIN
char	g_sym_tab [GSYMSZ];	/*	Global Symbol Table	*/
char	l_sym_tab [LSYMSZ];	/*	Local Symbol Table	*/
#else
extern char	g_sym_tab [GSYMSZ];	/*	Global Symbol Table	*/
extern char	l_sym_tab [LSYMSZ];	/*	Local Symbol Table	*/
#endif

#define	STARTGLB	&g_sym_tab [0]
#define	ENDGLB		&g_sym_tab [GSYMSZ - 1]
#define	STARTLOC	&l_sym_tab [0]
#define	ENDLOC		&l_sym_tab [LSYMSZ - 1]

/* symbol table entry format */
#define	IDENT    7
#define	TYPE     8
#define	OFFSET   9
#define	ROWSIZ  11

/* "while" statement queue */
#define	WQTABSZ		60
#define	WQSIZ		3
#define	WQMAX		57		/*	wq + WQTABSZ - WQSIZ	*/

/* macro (define) pool */
#define	MACQSIZE	1000


#ifdef C99_MAIN
char macro_pool [MACQSIZE];
#else
extern char	macro_pool [MACQSIZE];
#endif

#define	MACQ		&macro_pool [0]	/*	macro string buffer	*/
#define	MACMAX		&macro_pool [MACQSIZE - 1]

/*	"switch" table	*/
#define	SWTABSZ		120			/*	60 entries		*/
#define	SWEND		swq + 118

/*	possible values for "class"	*/
#define	STATIC		1
#define	EXTERNAL	2

/*	possible values for "TYPE"	*/
#define	UNKNOWN		0
#define	CCHAR		1
#define	CINT		2

/*	input line	*/
#define	LINESIZE	82
#define	LINEMAX		80	/*	LINESIZE - 2	*/

/*	System wide name size (for symbols)	*/
#define	NAMESIZE	7
#define	NAMEMAX		6

/*	Input/Output definitions	*/
#ifndef BACKSPACE
	#define	BACKSPACE	8
#endif

#ifndef TAB
	#define	TAB			9
#endif

#ifndef LINEFEED
	#define	LINEFEED	10
#endif

#ifndef FORMFEED
	#define	FORMFEED	12
#endif

#ifndef RETURN
	#define	RETURN		13
#endif

#ifndef SPACE
	#define	SPACE		32
#endif

#ifndef STAR
	#define	STAR		42
#endif

#ifndef BACKSLASH
	#define	BACKSLASH	92
#endif

/*	possible values for "IDENT"	*/
#define	LABEL		0
#define	VARIABLE	1
#define	ARRAY		2
#define	FUNCTION	3
#define	POINTER		4	/*	note that POINTER and PTRARR1/2		*/
#define	PTRAR1		5	/*	must be the highest valued items	*/
#define	PTRAR2		6	/*	in this list						*/

/*	statement types (tokens)	*/
#define	STIF		1
#define	STWHILE		2
#define	STRETURN	3
#define	STBREAK		4
#define	STCONT		5
#define	STASM		6
#define	STEXP		7
#define	STDO		8
#define	STFOR		9
#define	STSWITCH	10
#define	STCASE		11
#define	STDEF		12
#define	STGOTO		13
#define	STLABEL		14

/*	entry offsets in while queue	*/
#define	WQSP		0
#define	WQLOOP		1
#define	WQLAB		2

/*	literal pool	*/
#define  LITABSZ  4096
#define  LITMAX   4094	/*	LITABSZ-2	*/

#ifdef	C99_MAIN
short lit_pool[LITABSZ];
#else
extern short lit_pool[LITABSZ];
#endif

/*	Definitions for heirarchical parsing
**
** lval [0]-symbol table address, 0 for constant
** lval [1]-type of indirect object to fetch, 0 for static
** lval [2]-type of pointer or array, 0 otherwise
** lval [3]-Table Number:
**		0 = Unused.
**		1 = Global Symbol-Table.
**		2 = Local Symbol-Table.
**		3 = Macro Symbol-Table.
**		4 = Literal-Pool Symbol-Table.
*/

#define TABLE_UNKNOWN	0
#define TABLE_GLOBAL	1
#define TABLE_LOCAL		2
#define TABLE_MACRO		3
#define TABLE_LIT		4

#ifdef	C99_MAIN

short litptr;			/*	ptr to lit pool entry		*/
short cptr;				/*	work ptr to any char buffer		*/
short cptr2;				/*	work ptr to any char buffer		*/
short locptr;			/*	ptr to symtab entries			*/
char* macptr;			/*	macro buffer index				*/
char* lptrc;
char* mptrc;			/*	ptrs to line buffers		*/
char msname[NAMESIZE];	/*	macro name				*/

short swdefault;		/*	default label #				*/

short wq [WQTABSZ];		/*	while queue					*/
short stkp;				/*	compiler relative stk ptr	*/
short wqindex;			/*	ptr to next entry			*/
short* swnext;			/*	ptr to next entry			*/
short swq [SWTABSZ];	/*	switch table				*/
short swactive;			/*	true inside switch			*/
short iflv;				/*	#if... nesting level		*/
short skiplv;			/*	#if... level for skipping	*/
short pmode;			/*	true in #if... processing	*/
short test_mode;		/*	Non-zero = Diagnostic/debug mode.	*/
short numlin;			/*	# source lines processed	*/
short numglbs;			/*	# global symbols used		*/
short numlocs;			/*	max local symbols used		*/
short errcnt;			/*	# errors in compilation		*/
short errflg;			/*	true if error in statement	*/
short eof;				/*	set non-zero on final input eof */
short input;			/*	iob # for input file			*/
short input2;			/*	iob # for "include" file		*/
short output;			/*	iob # for output file (if any)	*/
short nxtlab;			/*	next avail label #				*/
short ncmp;				/*	# open compound statements		*/
short cmode;			/*	non-zero while parsing c-code	*/
						/*	zero when passing assembly code	*/
short decl;				/*	# local bytes declared			*/
BOOL ctext;				/*	non-zero to intermix c-source	*/
BOOL atext;				/*	non-zero to add assembly-source comments	*/
BOOL rtext;				/*	non-zero to add "r" before register numbers	*/
char* rstr;				/*  register string text			*/
BOOL pushin;			/*	non-zero for inline push code	*/
short lptr;				/*	line buffer indices				*/
short noloc;			/*	disables block locals			*/
short lastst;			/*	last executed statement type	*/
short litlab;			/*	label # assigned to literal pool	*/
short numltf;			/*	# local symbols in this fcn			*/
short nogo;				/*	disables goto						*/
short argtop;			/*	top of arg sp						*/
short argstk;			/*	function arg sp						*/
short mptr;				/*	line buffer indices					*/
BOOL needst = FALSE;	/*	set if ABS needed for conditionals	*/
short* iptr;			/*	work ptr to any int buffer			*/
short outcol = 1;		/*	column counter for tab function		*/


char mline[LINESIZE];			/*	temp macro buffer			*/
char ssname[NAMESIZE];			/*	symbol name					*/
char logo[80] = logtxt;			/*	banner text					*/
char quote[2] = {'"', '\0'};	/*	literal string for "		*/
char line[LINESIZE];			/*	parsing buffer				*/
char infile[LINESIZE] = { '\0' };	/*  input filename			*/
char outfile[LINESIZE] = { '\0' };	/*  output filename			*/

FILE* file_table[5] = { NULL, NULL, NULL, NULL, NULL } ;
char base_dir[LINESIZE];	/*	Base-directory for sources	*/

char* VarTypes[] =
{
	"Unk ",
	"Char",
	"Int ",
	""
};

char	*SymTypes [] =
{
	"Label   ",
	"Variable",
	"Array   ",
	"Function",
	"Pointer ",
	"Ptrar1  ",
	"Ptrar2  ",
	""
};

#else	/*	#ifdef C99_MAIN	*/

extern short cptr;				/*	work ptr to any char buffer		*/
extern short cptr2;				/*	work ptr to any char buffer		*/
extern short locptr;			/*	ptr to symtab entries			*/
extern char* macptr;			/*	macro buffer index				*/
extern char* lptrc;
extern char* mptrc;				/*	ptrs to line buffers			*/
extern char msname[NAMESIZE];	/*	macro name						*/
extern short swdefault;			/*	default label #				*/
extern short wq [WQTABSZ];		/*	while queue					*/
extern short stkp;				/*	compiler relative stk ptr	*/
extern short wqindex;			/*	ptr to next entry			*/
extern short* swnext;			/*	ptr to next entry			*/
extern short swq [SWTABSZ];		/*	switch table				*/
extern short swactive;			/*	true inside switch			*/
extern short iflv;				/*	#if... nesting level		*/
extern short skiplv;			/*	#if... level for skipping	*/
extern short pmode;				/*	true in #if... processing	*/
extern short test_mode;			/*	Non-zero = Diagnostic/debug mode.	*/
extern short numlin;			/*	# source lines processed	*/
extern short numglbs;			/*	# global symbols used		*/
extern short numlocs;			/*	max local symbols used		*/
extern short errcnt;			/*	# errors in compilation		*/
extern short errflg;			/*	true if error in statement	*/
extern short eof;				/*	set non-zero on final input eof */
extern short input;				/*	iob # for input file			*/
extern short output;			/*	iob # for output file (if any)	*/
extern short input2;			/*	iob # for "include" file		*/
extern short nxtlab;			/*	next avail label #				*/
extern short ncmp;				/*	# open compound statements		*/
extern BOOL cmode;				/*	non-zero while parsing c-code	*/
								/*	zero when passing assembly code	*/
extern short decl;				/*	# local bytes declared			*/
extern BOOL ctext;				/*	non-zero to intermix c-source	*/
extern BOOL atext;				/*	non-zero to add assembly-source comments	*/
extern BOOL rtext;				/*	non-zero to add "r" before register numbers	*/
extern BOOL pushin;				/*	non-zero for inline push code	*/
extern char* rstr;				/*  register string text			*/
extern short lptr;				/*	line buffer indices				*/
extern short noloc;				/*	disables block locals			*/
extern short lastst;			/*	last executed statement type	*/
extern short litlab;			/*	label # assigned to literal pool	*/
extern short numltf;			/*	# local symbols in this fcn			*/
extern short nogo;				/*	disables goto						*/
extern short argtop;			/*	top of arg sp						*/
extern short argstk;			/*	function arg sp						*/
extern short mptr;				/*	line buffer indices					*/
extern short needst;			/*	set if ABS needed for conditionals	*/
extern short* iptr;				/*	work ptr to any int buffer			*/
extern short litptr;			/*	ptr to lit pool entry				*/
extern short outcol;			/*	column counter for tab function		*/


extern char	mline[LINESIZE];		/*	temp macro buffer			*/
extern char	ssname[NAMESIZE];		/*	symbol name					*/
extern char	logo[80];				/*	banner text					*/
extern char	quote[2];				/*	literal string for "		*/
extern char	line[LINESIZE];			/*	parsing buffer				*/
extern char infile[LINESIZE];		/*  input filename				*/
extern char outfile[LINESIZE];		/*  output filename				*/

extern FILE	*file_table[5];
extern char	base_dir[LINESIZE];	/*	Base-directory for sources	*/
extern char	*VarTypes[];
extern char	*SymTypes[];

#endif /* C99_MAIN */

/*	Routines defined in c99c1.c		*/
void main(int argc, char* argv[]);
void parse(void);
void dumpglbsyms(void);
void dumplocsyms(void);
void dumpsyms(char *StartAddr, char *EndAddr);
void dumplits(short typ);
void sumstats(void);
void summary(void);
short ask_opts(int argc, char* argv[]);
BOOL get_opt(char* prompt);
void doinclude(void);
short dodeclare(short class);
void declglb(short typ, short class);   /* typ is CCHAR or CINT */
void declloc(short typ);		/* typ is CCHAR or CINT */
short needsub(void);
void doentry(void);
short cdim2(void);
void newfunc(void);
void getarg(short t);    /* t = CCHAR or CINT */
short statement(void);
void doif(void);
void dowhile(void);
void doif(void);
void dowhile(void);
void dodo(void);
void dofor(void);
void doswitch(void);
void docase(void);
void ns(void);
void doexpr(void);
void compound(void);
void dodefault(void);
void dogoto(void);
short dolabel(void);
void doreturn(void);
void dobreak(void);
void docont(void);
void doasm(void);

/*	Routines defined in c99c2.c		*/
void callfunction(char *ptr);		/* symbol table entry (or 0) */
short initials(short typ,short id,short dim);
short init(short typ,short id,short *dim);
void junk(void);
short endst(void);
void illname(void);
void multidef(void);
void needbrack(char *str);
void needlval(void);
void cnserr(void);
void ntcerr(void);
void oflerr(void);
void oocerr(void);
void ndcerr(void);
short findglb(char *sname); /*	Search for symbol in gloabl symbol-table.	*/
short findloc(char *sname); /*	Search for symbol in local symbol-table.	*/
short addglb(char *sname, short id, short typ, short value, short r);
short addloc(char *sname, short id, short typ, short value, short r);
void entsym(char *sname, char *Table, short id, short typ, short value, short rsiz);
short addlbl(void);
BOOL symname(char *sname);
short getlabel(void);
void printlabel(short label);
void prlbll(short label);
void pl(char *str);
void addwhile(short ptr []);
void delwhile(void);
short readwhile(short  ptr);
short cur_ch(void);		/*	"peek-ahead" to current character from input file.	*/
short next_ch(void);	/*	"peek-ahead" to next character from input file.		*/
short get_ch(void);		/*	Get a character from the input file.				*/
short isy(void);
void kill(void);
short inbyte(void);
short inchar(void);
void inline(void);
void ifline(void);
void noiferr(void);
short keepch(short c);
void preprocess(void);
void addmac(void);
short putmac(short c);
char* findmac(char *sname);
short outbyte(short c);
void outstr(char *ptr);
void outlbl(char *ptr);
void otlbll(char ptr []);
void outcom(char ptr[]);
void newline(void);
void tab(void);
void asmcomment(char* comment);
void errrpt(char *txt);
void outl(char ptr[]);
void ol(char ptr[]);
void ot(char ptr[]);
short match(char *lit);
short amatch(char *lit, short len);
void blanks(void);
short PDBody(short item);
short PHBody(short item);
short outhex(short item);
short outdec(short item);
void outdcl(short item);
short isptr(char *ptr);
short ischar(char *ptr);
short isword(short lval []);
short ptrchk(short lval [],short lval2 []);
void expression(void);
short heir1(short lval []);
short heir1a(short lval []); 
short heir1b(short lval []);
short heir2(short lval []);
short heir3(short lval []);
short heir4(short lval []);
short heir5(short lval []);
short heir6(short lval []);

/*	Routines defined in c99c3.c	*/
short heir7(short lval []);
short heir8(short lval []);
short heir9(short lval []);
short heir10(short lval []);
short heir11(short lval []);
short primary(short *lval);
short setl2(short lval [], char ptr []);
void step1(short lval [], short up);
void step2(short lval [], short up);
void updn(short lval [], short up);
short dolog(char *symb, char *opcode, char *dropop, char *endop, short (*heir)(), short lval []);
void droptst(short k, char *opcode, short label, short lval []);
void condexp(void);
void address(char *ptr);
void store(short lval []);
void rvalue(short lval []);
void test(short label, short paren);
void briff(short label);
short constant (short *val);
short constx(short *val);
void outval(short *lval);
short hexnum(short *val);
short number(short *val);
short pstr(short *val);
short qstr(short *val);
void stolit(short val, short siz);
short litchr(void);
void comment(void);
void header(void);
void trailer(void);
void ddata(void);
void getmem(char *sym);
void getloc(char *sym);
void putmem(char *sym);
void putstk(short typeobj);
void indirect(short typeobj);
void immed(void);
void push(void);
void pop(void);
void ret();
void dcall(char *sname);
void jump(short label);
short modstk(short newsp);
void doublereg(void);
void add(void);
void clrp(void);

/*	Routines defined in c99csb.c	*/
short getfn(short inp, char* fn, char *m);

short getlit(short litptr, short type);
void putlit(short val, short litptr, short size);
short tiputc(short c, short unit);
short tfclose(short unit);
short tfopen(char *name, char *mode);
short getlit(short litptr, short type);
void putlit(short val, short litptr, short size);
short hash(char *sname);
short alpha(short c);
short alnum(short c);
short numeric(short c);
short getint(char *addr);
void putint(short i, char *addr);
short streq(char *str);
short astreq(char str1 [], char str2 [], short len);
short cfread(char *str1, short unit);
short tiputchar(short c);
short tiputs(char *str);
short tigets(char *str, short max);
short tifopen(char *name, char *mode);
short tifclose(short unit);

#endif /* C99_H */