/* >>>>>>> start of c99c2 <<<<<<<<< 
**
** (c) 1987 by Clint Pulley
**
** Last Edit 87/03/05  2300
** Edit # ???  : 28-Dec-99  0100  (Kristine Rogers)
*/
/*
** Perform a function call
**
** called from heir11, this routine will either call
** the named function, or if the supplied ptr is
** zero, will call the address in R8
*/

#include <stdio.h>
#include <ctype.h>
#pragma inline_depth (250)
#pragma inline_recursion (on)
#include <process.h>
#include <stdlib.h>

#include "c99.h"

void callfunction(char *pointer)		/* symbol table entry (or NULL) */
{
	short nargs = 0;
	char buffer[81] = { '\0' };

	blanks();  /* already saw open paren */

	if (!pointer)
	{
		ot("MOV"); /* save call addr */

		sprintf(buffer, "%s8, @C$CALL", rstr);
		ol(buffer);
	}

	while (!streq(")"))
	{
		if (endst())
		{
			break;
		}

		expression();  /* get an argument */
		push();

		nargs = (short)(nargs + 2);  /* count args*2 */

		if (!match(","))
		{
			break;
		}
	}

	needbrack (")");

	if (pointer)
	{
		ot("BL");
		sprintf(buffer, "*%s12", rstr);
		ot(buffer);

		asmcomment("*   call a function");

		newline();
		ddata(); 
		otlbll(pointer);
	}
	else
	{
		dcall("CIND");
	}

	stkp = modstk(stkp + nargs);  /* clean up arguments */

	needst = TRUE;
}

/* initialize global objects
*/
short initials(short typ, short id, short dim)
{
	short saved = 0;
	short needll = 0;

	litptr = 0;

	if (!dim)
	{
		dim = -1;
	}

	saved = dim;

	outlbl(ssname);

	if (match("="))
	{ 
		newline();
		litlab = getlabel();

		if (match("{"))
		{ 
			while (dim)
			{ 
				needll = init(typ, id, &dim);

				if (!match(","))
				{
					break;
				}
			}

			needbrack ("}");
		}
		else
		{
			needll = init(typ, id, &dim);
		}
	}

	if ((dim == -1) && (dim == saved))
	{ 
		typ = CINT;
		stolit(0, typ);

		id = ((id == PTRAR1) ? PTRAR2 : POINTER);
	}

	if ((id >= POINTER) && (dim > 0))
	{ 
		ot("BSS");
		tab();
		outdcl(dim << 1);
	}

	if (needll)
	{
		prlbll(litlab);
	}

	dumplits(typ);

	if ((id < POINTER) && (dim > 0))
	{ 
		ot("BSS");
		tab();
		outdcl(dim * typ);
	}

	return id;
}

/* evaluate one initializer
*/
short init(short typ, short id, short* dim)
{
	short val = 0;
	short nllflg = 0;

	if (qstr(&val))
	{ 
		if ((id == VARIABLE) || (typ != CCHAR))
		{
			errrpt("Must be pointer or array type.");
		}

		if (id >= POINTER)
		{
			--*dim;
		}
		else
		{
			*dim = *dim - (litptr - val);
		}

		if (id >= POINTER)
		{ 
			ot("DATA");
			tab();
			printlabel(litlab);

			if (val)
			{ 
				outbyte('+');
				outdec(val);
			}

			newline();

			++nllflg;
		}
	}
	else
	{
		if (constx(&val))
		{ 
			if (id >= POINTER)
			{
				errrpt("Cannot use a pointer type.");
			}

			stolit(val, typ);

			--*dim;
		}
	}

	return nllflg;
}

void junk(void)
{
	if (alnum(inbyte()))
	{
		while (alnum(cur_ch()))
		{
			get_ch();
		}
	}
	else
	{
		while (!alnum(cur_ch()))
		{
			if (!cur_ch())
			{
				break;
			}

			get_ch();
		}
	}

	blanks();
}


BOOL endst(void)
{
	blanks();

	return (streq(";") || !cur_ch());
}

void illname(void)
{
	errrpt("Illegal identifier name.");
	junk();
}

void multidef(void)
{
	errrpt("Symbol is already defined.");
}

void needbrack(char* str)
{
	char* tptr = NULL;
	char tknmsg[81] = { '\0' };

	if (match(str))
	{
		return;
	}

	sprintf(tknmsg, "Missing token '%s'.", str);
	errrpt(tknmsg);
}

void needlval(void)
{
	errrpt("Must use an LVALUE type here.");
}

void cnserr(void)
{
	errrpt("Cannot use subscripts on this type.");
}

void ntcerr(void)
{
	errrpt("Must be a constant value.");
}

void oflerr(void)
{
	errrpt("Compiler table overflow.");
}

void oocerr(void)
{
	errrpt("Construct used out of context.");
}

void ndcerr(void)
{
	errrpt("Missing comma ','.");
}

/* search global symbol table
** return cptr if name found
** return 0 if not found (cptr->new entry)
** set cptr2=0 if table full
*/
short findglb(char* sname)	/*	Search for symbol in gloabl symbol-table.	*/
{
	short index = ((hash(sname) & GHSHMSK) * SYMSIZ);

	cptr2 = index;
	cptr = cptr2;

	while (g_sym_tab[cptr] != '\0')
	{
		if (astreq(sname, &g_sym_tab [cptr], NAMEMAX))
		{
			return cptr;
		}

		cptr = (short)(cptr + SYMSIZ);

		if (cptr >= GSYMSZ)
		{
			cptr = 0;
		}

		if (cptr == cptr2)
		{
			cptr2 = 0;

			return 0;
		}
	}

	return 0;
}

short findloc(char* sname)	/*	Search for symbol in local symbol-table.	*/
{
	short my_ptr = SYMSIZ;

	while (my_ptr < locptr)
	{
		if (astreq(sname, &l_sym_tab [my_ptr], NAMEMAX))
		{
			return my_ptr;
		}

		my_ptr = (short)(my_ptr + SYMSIZ);
	}

	return 0;
}

short addglb(char *sname, short id, short typ, short value, short r)
{
	if (findglb(sname))
	{
		return cptr;
	}

	if (!cptr2)
	{
		oflerr();
		return 0;
	}

	entsym(sname, g_sym_tab, id, typ, value, r);

	++numglbs;

	return cptr;
}

short addloc(char *sname, short ident, short vartyp, short value, short r)
{
	cptr = findloc(sname);

	if (!cptr)
	{
		if (locptr >= LSYMSZ)
		{
			oflerr();
			return 0;
		}

		cptr = locptr;

		entsym(sname, l_sym_tab, ident, vartyp, value, r);

		locptr = (short)(locptr + SYMSIZ);

		++numltf;
	}

	return cptr;
}

void entsym(char *sname, char *Table, short id, short typ, short value, short rsiz)
{
	short my_ptr = cptr;

	while (alnum(*sname))  /* copy name */
	{
		Table[my_ptr++] = *sname++;
	}

	Table[my_ptr] = '\0';

	Table[cptr + IDENT] = (char)id;
	Table[cptr + TYPE] = (char)typ;

	putint(value, &Table[cptr + OFFSET]);
	putint(rsiz, &Table[cptr + ROWSIZ]);
}

short addlbl(void)
{
	short result = 0;

	addloc(ssname, LABEL, LABEL, getlabel(), 0);

	if (l_sym_tab[cptr + IDENT] != LABEL)
	{
		errrpt("Symbol is not a label.");
	}

	result = getint(&l_sym_tab[cptr + OFFSET]);

	return result;
}

/* Test if next input string is legal symbol name */
BOOL symname(char *sname)
{
	short k = 0;

	blanks();

	if (!alpha(cur_ch()))
	{
		return FALSE;
	}
	while (alnum(cur_ch()))
	{
		sname[k++] = (char)get_ch();
	}

	sname[k] = '\0';

	return TRUE;
}

/* Return next avail internal label number */
short getlabel(void)
{
	return (++nxtlab);
}

/* Print specified number as label */
void printlabel(short label)
{
	outstr("C$");
	outdec(label);
}

void prlbll(short label)
{
	printlabel(label);
	newline();
}

/* Print a carriage return and a string only to console */
void pl(char *str)
{
	PUTCHAR(LINEFEED);
	PUTS(str);
}

void
addwhile(short pointer [])
{
	short k = 0;

	pointer[WQSP] = stkp;			/*	save stack ptr		*/
	pointer[WQLOOP] = getlabel();	/*	and looping label	*/
	pointer[WQLAB] = getlabel();	/*	and exit label		*/

	if (wqindex >= WQMAX)
	{ 
		oflerr(); 
		return;
	}

	while (k < WQSIZ)
	{
		wq[wqindex++] = pointer[k++];
	}
}

void delwhile(void)
{
	if (wqindex > 0)
	{
		wqindex = (short)(wqindex - WQSIZ);
	}
}

short readwhile(short index)
{
	short result = 0;

	if (index <= 0)
	{
		oocerr();
	}
	else
	{
		result = (short)(index - WQSIZ);
	}

	return result;
}

short cur_ch(void)		/*	"peek-ahead" to current character from input file.	*/
{
	return (line[lptr] & 0xff);
}

short next_ch(void)		/*	"peek-ahead" to next character from input file.	*/
{
	return (cur_ch() ? (line[lptr + 1] & 0xff) : 0);
}

short get_ch(void)			/*	Get a character from the input file.	*/
{
	return (cur_ch() ? (line[lptr++] & 0xff) : 0);
}

short isy(void)
{
	return ((line[0] == 'y') || (line [0] == 'Y'));
}

void kill(void)
{
	lptr = 0;
	line[0] = '\0';
}

short inbyte(void)
{
	while (!cur_ch())
	{ 
		if (eof)
		{
			return 0;
		}

		preprocess();
	}

	return get_ch();
}

short inchar(void)
{
	if (!cur_ch())
	{
		inline();
	}

	if (eof)
	{
		return 0;
	}

	return get_ch();
}

void inline(void)		/*	Read a line from input file.	*/
{
	short unit = 0;

	errflg = 0;

	for ( ; ; )
	{ 
		if (eof)
		{
			return;
		}

		unit = input2;

		if (!unit)
		{
			unit = input;
		}

		kill();

		lptr = cfread(line, unit);

		++numlin;

		if (lptr <= 0)
		{ 
			FCLOSE(unit);

			unit = 0;

			kill();

			if (input2)
			{
				input2 = 0;
			}
			else
			{
				eof = TRUE;
			}
		}

		if (lptr)
		{ 
			if (ctext && cmode)
			{
				outcom(line);
			}

			lptr = 0;

			if (test_mode)
			{
				PUTS(line);
				PUTS("\n");
			}

			return;
		}
	}
}

/* process conditional compile directives */
void ifline(void)	/*	Check #ifdef-type lines	*/
{
	pmode = TRUE;

	for ( ; ; )
	{ 
		inline();

		if (eof)
		{
			break;
		}

		blanks();

		if (cur_ch() == '#')
		{ 
			if (match("#ifdef"))
			{ 
				++iflv;

				if (skiplv)
				{
					continue;
				}

				if (symname(msname))
				{
					if (findmac(msname))
					{
						skiplv = iflv;
					}
				}

				continue;
			}

			if (match("#ifndef"))
			{
				++iflv;

				if (skiplv)
				{
					continue;
				}

				if (symname(msname))
				{
					if (findmac(msname))
					{
						skiplv = iflv;
					}
				}
				continue;
			}

			if (match("#else"))
			{ 
				if (iflv)
				{ 
					if (skiplv == iflv)
					{
						skiplv = 0;
					}
					else
					{
						if (!skiplv)
						{
							skiplv = iflv;
						}
					}
				}
				else
				{
					noiferr();
				}
				continue;
			}

			if (match("#endif"))
			{ 
				if (iflv)
				{ 
					if (skiplv == iflv)
					{
						skiplv = 0;
					}

					--iflv;
				}
				else
				{
					noiferr();
				}
				continue;
			}
		}

		if (skiplv)
		{
			continue;
		}

		break;
	}

	pmode = FALSE;
}

void noiferr(void)
{
	errrpt ("Missing matching #if directive.");
}

short keepch(short c)
{
	mline[mptr] = (char)c;

	if (mptr < LINEMAX)
	{
		mptr++;
	}

	return c;
}

void preprocess(void)
{
	char* cp = NULL;
	short k = 0;
	short c = 0;

	if (cmode)
	{ 
		ifline();

		if (eof)
		{
			return;
		}
	}
	else
	{ 
		inline();
		return;
	}

	mptr = 0;
	lptr = 0;

	while (cur_ch())
	{
		if (isspace(cur_ch()))
		{
			keepch(SPACE);

			while (isspace(cur_ch()))
			{
				get_ch();
			}
		}
		else
		{
			if (cur_ch() == '"')
			{
				keepch(cur_ch());

				get_ch();

				while (cur_ch() != '"')
				{
					if (!cur_ch())
					{
						errrpt("Missing closing double quote '\"'.");
						break;
					}

					keepch(get_ch());
				}

				get_ch();
				keepch('"');
			}
			else
			{
				if (cur_ch() == '\'')
				{
					keepch('\'');
					get_ch();

					while (cur_ch() != '\'')
					{
						if (!cur_ch())
						{
							errrpt ("Missing closing single quote \"'\".");
							break;
						}

						keepch(get_ch());
					}

					get_ch();
					keepch('\'');
				}
				else
				{
					if ((cur_ch() == '/')  && (next_ch() == '*'))
					{
						/*	Filter-out comments.	*/
						inchar();
						inchar();

						for ( ; ; )
						{
							if (inchar() == '*')
							{
								if (cur_ch() == '/')
								{
									/*	End of comment.	*/
									break;
								}
							}

							if (eof)
							{
								break;
							}
						}

						inchar();
					}
					else
					{
						if (alnum(cur_ch()))
						{
							k = 0;

							while (alnum(cur_ch()))
							{
								if (k < NAMEMAX)
								{
									msname [k++] = (char)cur_ch();
								}

								get_ch();
							}

							msname[k] = '\0';
							cp = NULL;

							if (alpha(cur_ch()))
							{
								cp = findmac(msname);
							}

							if (!cp)
							{
								cp = msname;
							}

							while (*cp != '\0')
							{
								c = *cp++;
								keepch(c);
							}
						}
						else
						{
							keepch(get_ch());
						}
					}
				}
			}
		}
	}

	keepch(0);

	if (mptr >= LINEMAX)
	{
		errrpt("Input line is too long.");
	}

	lptrc = line; 
	mptrc = mline;

	*lptrc = *mptrc;

	while (*mptrc != '\0')
	{
		*lptrc++ = *mptrc++;		
	}

	*lptrc = '\0';

	lptr = 0;
}

void addmac(void)
{
	char* k = NULL;

	if (!symname(msname))
	{ 
		illname();
		kill();
		return;
	}

	k = msname;

	while (putmac(*k))
	{
		k++;
	}

	while (cur_ch())
	{ 
		if (isspace(cur_ch()))
		{
			get_ch();
		}
		else
		{
			break;
		}
	}

	while (putmac(get_ch()))
	{
		;
	}

	if (macptr >= MACMAX)
	{
		oflerr();
	}
}

short putmac(short c)
{
	*macptr = (char)c;

	if (macptr < MACMAX)
	{
		macptr++;
	}

	return c;
}

char* findmac(char *sname)
{
	char* k = MACQ;

	while (k < macptr)
	{
		if (astreq(sname, k, NAMEMAX))
		{
			while (*k != '\0')
			{
				k++;
			}

			k++;		/*	Skip-over intervening zero-byte.	*/

			return k;	/*	Return pointer to definition.		*/
		}

		while (*k != '\0')
		{
			k++;		/*	Skip-over any remaining portion of name.	*/
		}

		k++;		/*	Skip-over intervening zero-byte.	*/

		while ((*k != '\0') && (k < macptr))
		{
			k++;		/*	Skip-over definition.	*/
		}

		k++;		/*	Skip-over intervening zero-byte.	*/
	}

	return NULL;
}

short outbyte(short c)
{
	if (c)
	{
		outcol++;

		if (c == '\n')
		{
			outcol = 1;
		}

		if ((PUTC(c, output)) <= 0)
		{ 
			errrpt ("Error writing to output file.");
			exit(1);
		}
	}

	return c;
}

void outstr(char* pointer)
{
	while (*pointer != '\0')
	{
		outbyte(*pointer);
		pointer++;
	}
}

void outlbl(char* pointer)
{
	short c = *pointer;

	while (*pointer != '\0')
	{ 
		c = *pointer++;

		if ((c > 96) && (c < 123))
		{
			c = (short) (c - 32);
		}

		if (c == '_')
		{
			c = '#';
		}

		outbyte(c);
	}
}

void otlbll(char pointer [])
{
	outlbl(pointer); 
	newline();
}

void outcom(char pointer [])	/*	Print the referenced string as a comment.	*/
{
	comment();
	outl(pointer);
}

void newline(void)	/*	Go to the next line.	*/
{
	outbyte(LINEFEED);
}

void tab(void)		/*	Move to the next eightth-column.	*/
{
	outbyte(SPACE);	/*	Send at least one space.	*/

	while (outcol & 7)
	{
		outbyte(SPACE);
	}
}

void asmcomment(char* comment)
{
	if (atext)
	{
		while (outcol < 32)
		{
			tab();
		}

		ot(comment);
	}
}

void errrpt(char* txt)
{
	char dummy[LINESIZE] = { '\0' };
	short k = 0;

	if (errflg)
	{
		return;
	}

	errflg = 1;

	pl("!! Error : "); 
	outl(" ************************************ ");
	outstr("!! Error : "); 

	PUTS(txt);
	outl(txt);
	pl(line); 
	outl(line); 

	PUTCHAR(LINEFEED);

	while (++k < lptr)
	{
		PUTCHAR(SPACE);
		outbyte(SPACE);
	}

	PUTCHAR('^');
	outbyte('^');
	outbyte(LINEFEED);
	outl(" ************************************ ");

	if (++errcnt > 40)
	{
		pl(">40 errors\n");
		exit(1);
	}

	tigets(dummy, LINEMAX);

	if ((dummy [0] == 'q') || (dummy [0] == 'Q'))
	{
		if (get_opt("Really quit? [n] "))
		{
			ol(" Compilation aborted by user. ");
			FCLOSE(input);
			input = 0;

			FCLOSE(output);
			output = 0;

			exit(1);
		}
	}
}

void outl(char pointer [])
{
	outstr(pointer);
	newline();
}

void ol(char pointer [])
{
	ot(pointer);
	newline();
}

void ot(char pointer [])
{
	tab();
	outstr(pointer);
}

short match(char* lit)
{
	short k = 0;

	blanks();

	k = streq(lit);

	if (k)
	{
		lptr = lptr + k;

		return TRUE;
	}

	return FALSE;
}

short amatch(char* lit, short len)
{
	short k = 0;

	blanks();

	k = astreq(line + lptr, lit, len);

	if (k)
	{
		lptr = lptr + k;

		while (alnum(cur_ch()))
		{
			inbyte();
		}

		return TRUE;
	}

	return FALSE;
}

void blanks(void)
{
	for ( ; ; )
	{ 
		while (cur_ch())
		{ 

			if (!isspace(cur_ch()))
			{
				return;
			}

			get_ch();
		}

		if (pmode)
		{
			return;
		}

		preprocess();

		if (eof)
		{
			break;
		}
	}
}

short PDBody(short item)
{
	short chtr = 0;
	short size = 0;

	if (item)
	{
		chtr = ((item % 10) + '0');	/*	Calculate rightmost character	*/

		item /= 10;

		size = PDBody(item);

		outbyte(chtr);

		size++;
	}

	return size;
}

short PHBody(short item)
{
	short chtr = 0;
	short size = 0;

	if (item)
	{
		chtr = ((item & 0xf) + '0');	/*	Calculate rightmost character	*/

		if (chtr > '9')
		{
			chtr += 7;
		}

		item >>= 4;
		item &= 0xfff;

		size = PHBody(item);
		outbyte(chtr);

		size++;
	}

	return size;
}

short outdec(short item)
{
	short size = 0;

	if (!item)
	{
		outbyte('0');
		return 1;
	}
	else
	{
		if (item == (16384 << 1))
		{ 
			outstr("32768");
			return 5;
		} 
		else if (item < 0)
		{ 
			outbyte('-');
			size = PDBody(-item);
		}
		else
		{
			size = PDBody(item);
		}
	}

	return size;
}


short outhex(short item)
{
	short size = 0;

	if (!item)
	{
		outbyte('0');
		return 1;
	}

	size = PHBody(item);

	return size;
}

void outdcl(short item)
{
	outdec(item); 
	newline();
}

short isptr(char* pointer)
{
	return (pointer[IDENT] >= POINTER);
}

short ischar(char *pointer)
{
	return (!isptr(pointer) && (pointer[TYPE] == CCHAR));
}

short isword(short lval [])
{
	return (lval[2] == CINT);
}

short ptrchk(short lval [], short lval2 [])
{
	return (lval[2] | lval2[2]);
}


/* heirarchical parsing
**
** lval [0]-symbol table address, 0 for constant
** lval [1]-type of indirect object to fetch, 0 for static
** lval [2]-type of pointer or array, 0 otherwise
** lval [3]-Table Number:
**	0 = Unused.
**	1 = Global Symbol-Table.
**	2 = Local Symbol-Table.
**	3 = Macro Symbol-Table.
*/
void expression(void)
{
	short lval[4] = { 0 };

	if (heir1(lval))
	{
		rvalue(lval);
	}
}

short heir1(short lval [])
{
	short cx1 = 0;
	short* cx2 = NULL;	
	short lval2[4] = { 0 };

	short k = heir1a(lval);

	if (match("?"))
	{ 
		if (k)
		{
			rvalue(lval);
		}

		condexp();

		k = 0;
	}

	if (!match("="))
	{
		return k;
	}

	if (!k)
	{
		needlval();
		return 0;
	}

	if (lval[1])
	{
		push();
	}

	if (heir1(lval2))
	{
		rvalue(lval2);
	}

	if (match ("?"))
	{ 
		cx1 = lval[1];
		cx2 = lval;

		condexp();

		lval[1] = cx1;
		lval = cx2;
	}

	store(lval);

	return 0;
}

short heir1a(short lval [])
{
	char* st1 = rtext ? "MOV     R15, R8" : "MOV     15, 8";
	char* st2 = rtext ? "S       R8, R8" : "S       8, 8";

	return dolog("||", "JEQ", st1, st2, heir1b, lval);
}


short heir1b(short lval [])
{
	char* st1 = rtext ? "S       R8, R8" : "S       8, 8";
	char* st2 = rtext ? "MOV     R15, R8" : "MOV     15, 8";

	return dolog ("&&", "JNE", st1, st2, heir2, lval);
}

short heir2(short lval [])
{	
	short lval2[4] = { 0 };

	short k = heir3(lval);

	blanks();

	if (cur_ch() != '|')
	{
		return k;
	}

	if (streq("||"))
	{
		return k;
	}

	if (k)
	{
		rvalue(lval);
	}

	for ( ; ; )
	{
		if (match("|"))
		{
			push();

			if (heir3(lval2))
			{
				rvalue(lval2);
			}

			pop();
			ot("SOC");
			ol((rtext ? "*R14+, R8" : "*14+, 8"));

			needst = FALSE;
		}
		else
		{
			return 0;
		}
	}
}

short heir3(short lval [])
{	
	short lval2[4] = { 0 };

	short k = heir4 (lval);

	blanks ();

	if (cur_ch() != '^')
	{
		return k;
	}

	if (k)
	{
		rvalue(lval);
	}

	for ( ; ; )
	{
		if (match("^"))
		{
			push();

			if (heir4(lval2))
			{
				rvalue(lval2);
			}

			pop();
			ot("XOR");
			ol((rtext ? "*R14+, R8" : "*14+, 8"));

			needst = FALSE;
		}
		else
		{
			return 0;
		}
	}
}

short heir4(short lval [])
{
	short lval2[4] = { '\0' };

	short k = heir5(lval);

	blanks();

	if (cur_ch() != '&')
	{
		return k;
	}

	if (streq("&&"))
	{
		return k;
	}

	if (k)
	{
		rvalue(lval);
	}

	for ( ; ; )
	{
		if (match("&"))
		{
			push();

			if (heir5(lval2))
			{
				rvalue(lval2);
			}

			pop();

			ot("INV");			
			ol((rtext ? "*R14" : "*14"));

			ot("SZC");
			ol((rtext ? "*R14+, R8" : "*14+, 8"));

			needst = FALSE;
		}
		else
		{
			return 0;
		}
	}
}

short heir5(short lval [])
{
	short lval2[4] = { 0 };

	short k = heir6(lval);

	blanks();

	if (!streq("==") && !streq("!="))
	{
		return k;
	}

	if (k)
	{
		rvalue(lval);
	}

	for ( ; ; )
	{
		if (match("=="))
		{
			push();

			if (heir6(lval2))
			{
				rvalue(lval2);
			}

			pop();
			dcall("EQ");
		}
		else if (match("!="))
		{
			push();

			if (heir6(lval2))
			{
				rvalue(lval2);
			}

			pop();

			dcall("NE");
		}
		else
		{
			return 0;
		}
	}
}

short heir6(short lval [])
{
	short lval2[4] = { 0 };

	short k = heir7(lval);

	blanks();

	if (!streq("<") && !streq(">") && !streq("<=") && !streq(">="))
	{
		return k;
	}

	if (streq(">>"))
	{
		return k;
	}

	if (streq("<<"))
	{
		return k;
	}

	if (k)
	{
		rvalue(lval);
	}

	for ( ; ; )
	{
		if (match("<="))
		{
			push();

			if (heir7(lval2))
			{
				rvalue(lval2);
			}

			pop();
			dcall((ptrchk(lval, lval2) ? "ULE" : "LE"));
		}
		else if (match(">="))
		{
			push();

			if (heir7(lval2))
			{
				rvalue(lval2);
			}

			pop();
			dcall((ptrchk(lval, lval2) ? "UGE" : "GE"));
		}
		else if (streq("<") && !streq("<<"))
		{
			inbyte();
			push();

			if (heir7(lval2))
			{
				rvalue(lval2);
			}

			pop();
			dcall((ptrchk(lval, lval2) ? "ULT" : "LT"));
		}
		else if (streq(">") && !streq(">>"))
		{
			inbyte();
			push();

			if (heir7(lval2))
			{
				rvalue(lval2);
			}

			pop();
			dcall((ptrchk(lval, lval2) ? "UGT" : "GT"));
		}
		else
		{
			return 0;
		}
	}
}