/* >>>>>> start of c99c3 <<<<<< 
**
** (c) 1987 by Clint Pulley
**
** Last Edit 87/03/05  2300
** Edit # ???  : 28-Dec-99  0100  (Kristine Rogers)
*/

#include <stdio.h>
#pragma inline_depth (250)
#pragma inline_recursion (on)

#include "c99.h"

short heir7(short lval [])
{
	short lval2[4] = { 0 };

	short k = heir8(lval);

	blanks();

	if (!streq(">>") && !streq("<<"))
	{
		return k;
	}

	if (k)
	{
		rvalue(lval);
	}

	for ( ; ; )
	{
		if (match(">>"))
		{
			push();

			if (heir8(lval2))
			{
				rvalue(lval2);
			}

			pop();
			dcall("ASR"); /* shift right (R8) bits */

			continue;
		}

		if (match("<<"))
		{
			push();

			if (heir8(lval2))
			{
				rvalue(lval2);
			}

			pop();
			dcall("ASL"); /* shift left (R8) bits */

			continue;
		}

		return 0;
	}
}

short heir8(short lval [])
{
	short lval2[4] = { 0 };

	short k = heir9(lval);

	blanks();

	if ((cur_ch() != '+') && (cur_ch() != '-'))
	{
		return k;
	}

	if (k)
	{
		rvalue(lval);
	}

	for ( ; ; )
	{
		if (match("+"))
		{
			push();

			if (heir9(lval2))
			{
				rvalue(lval2);
			}

			if (isword(lval))
			{
				doublereg();
			}

			pop();
			add();

			continue;
		}

		if (match("-"))
		{
			push();

			if (heir9(lval2))
			{
				rvalue(lval2);
			}

			if (isword(lval) && !isword(lval2))
			{
				doublereg();
			}

			pop();

			ot("S");
			ot((rtext ? "*R14+, R8" : "*14+, 8"));
			newline();

			ot("NEG");
			ot((rtext ? "R8" : "8"));
			newline();

			if (isword(lval) && isword(lval2))
			{
				ot("SRA");
				ol((rtext ? "R8, 1" : "8, 1"));
			}

			needst = FALSE;

			continue;
		}

		return 0;
	}
}

short heir9(short lval [])
{
	short lval2[4] = { 0 };

	short k = heir10(lval);

	blanks();

	if ((cur_ch() != '*') && (cur_ch() != '/') && (cur_ch() != '%'))
	{
		return k;
	}

	if (k)
	{
		rvalue(lval);
	}

	for ( ; ; )
	{
		if (match ("*"))
		{
			push();

			if (heir9(lval2))
			{
				rvalue(lval2);
			}

			pop ();

			ot("MPY");
			ol((rtext ? "*R14+, R8" : "*14+, 8"));

			ot("MOV");
			ol((rtext ? "R9, R8" : "9, 8"));

			needst = FALSE;

			continue;
		}

		if (match("/"))
		{
			push();

			if (heir10(lval2))
			{
				rvalue(lval2);
			}

			pop();
			dcall("DIV");

			continue;
		}

		if (match("%"))
		{
			push();

			if (heir10(lval2))
			{
				rvalue(lval2);
			}

			pop();
			dcall("REM");

			continue;
		}

		return 0;
	}
}

short heir10(short lval [])
{
	short my_ptr = 0;
	short k = 0;
	char* table_base = NULL;

	if (match("++"))
	{
		if (!heir10(lval))
		{
			needlval();

			return 0;
		}

		step1(lval, 1);

		return 0;
	}

	if (match("--"))
	{
		if (!heir10(lval))
		{
			needlval();
			return 0;
		}

		step1(lval, 0);

		return 0;
	}

	if (match("-"))
	{ 
		if (heir10(lval))
		{
			rvalue(lval);
		}

		ot("NEG");
		ol((rtext ? "R8" : "8"));

		needst = FALSE;

		return 0;
	}

	if (match("~"))
	{ 
		if (heir10(lval))
		{
			rvalue(lval);
		}

		ot ("INV");
		ol((rtext ? "R8" : "8"));

		needst = FALSE;

		return (0);
	}

	if (match("!"))
	{ 
		if (heir10(lval))
		{
			rvalue(lval);
		}

		dcall("LNEG");

		return 0;
	}

	if (match("*"))
	{ 
		if (heir10(lval))
		{
			rvalue(lval);
		}

		lval[1] = CINT;
		lval[2] = 0;
		my_ptr = *lval;

		switch (lval[3])
		{
		  case TABLE_GLOBAL:
			table_base = g_sym_tab;
			break;

		  case TABLE_LOCAL:
			table_base = l_sym_tab;
			break;

		  case TABLE_MACRO:
			table_base = macro_pool;
			break;

		  default:
			break;
		}

		if (my_ptr)
		{
			lval[1] = table_base[my_ptr + TYPE];
		}

		needst = FALSE;

		return 1;
	}

	if (match("&"))
	{ 
		if (!heir10(lval))
		{ 
			errrpt ("Invalid address.");
			return 0;
		}

		my_ptr = *lval;

		switch (lval[3])
		{
		  case TABLE_GLOBAL:
			table_base = g_sym_tab;
			break;

		  case TABLE_LOCAL:
			table_base = l_sym_tab;
			break;

		  case TABLE_MACRO:
			table_base = macro_pool;
			break;

		  default:
			break;
		}

		setl2(lval, &table_base[my_ptr]);

		if (lval[1])
		{ 
			return 0;
		}

		address(&table_base[my_ptr]);
		lval[1] = table_base[my_ptr + TYPE];

		return 0;
	}

	k = heir11(lval);

	if (match("++"))
	{
		if (!k)
		{
			needlval();

			return 0;
		}

		step2(lval, 1);

		return 0;
	}

	if (match ("--"))
	{
		if (!k)
		{
			needlval();

			return 0;
		}

		step2(lval, 0);

		return 0;
	}

	return k;
}

short heir11(short lval [])
{
	short my_ptr = 0;
	char* table_base = NULL;

	short k = primary(lval);

	switch (lval[3])
	{
	  case TABLE_GLOBAL:
		table_base = g_sym_tab;
		break;

	  case TABLE_LOCAL:
		table_base = l_sym_tab;
		break;

	  case TABLE_MACRO:
		table_base = macro_pool;
		break;

	  default:
		break;
	}

	my_ptr = *lval;

	blanks();

	if ((cur_ch() == '[') || (cur_ch() == '('))
	{
		for ( ; ; )
		{
			if (match ("["))
			{
				if (!my_ptr)
				{ 
					cnserr();
					junk();
					needbrack("]");

					return 0;
				}
				else
				{
					switch (lval[3])
					{
					  case TABLE_GLOBAL:
						table_base = g_sym_tab;
						break;

					  case TABLE_LOCAL:
						table_base = l_sym_tab;
						break;

					  case TABLE_MACRO:
						table_base = macro_pool;
						break;

					  default:
						break;
					}

					if ((table_base[my_ptr + IDENT] == POINTER) || (table_base[my_ptr + IDENT] == PTRAR2))
					{
						rvalue(lval);
					}
					else if ((table_base[my_ptr + IDENT] != ARRAY) && !isptr(&table_base[my_ptr]))
					{ 
						cnserr();
						k = 0;
					}
				}

				push();

				expression();
				needbrack("]");

				switch (lval[3])
				{
				  case TABLE_GLOBAL:
					table_base = g_sym_tab;
					break;

				  case TABLE_LOCAL:
					table_base = l_sym_tab;
					break;

				  case TABLE_MACRO:
					table_base = macro_pool;
					break;

				  default:
					break;
				}

				if (match("["))  /* check for 2nd subscript */
				{ 
					ot((rtext ? "LI R7," : "LI 7,"));
					outdcl(getint(&table_base[my_ptr + ROWSIZ]));

					ot("MPY");		/*	Row * Rowsize	*/
					ol((rtext ? "R8, R7" : "8, 7"));

					push();

					expression(); /* eval 2nd subscript */
					needbrack("]");

					pop();

					add(); /* column */
				}

				switch (lval[3])
				{
				  case TABLE_GLOBAL:
					table_base = g_sym_tab;
					break;

				  case TABLE_LOCAL:
					table_base = l_sym_tab;
					break;

				  case TABLE_MACRO:
					table_base = macro_pool;
					break;

				  default:
					break;
				}

				if ((table_base[my_ptr + TYPE] == CINT) || (table_base[my_ptr + IDENT] >= PTRAR1))
				{
					doublereg();
				}

				pop();
				add();

				if (table_base[my_ptr + IDENT] >= PTRAR1)
				{ 
					lval[1] = CINT;
					setl2(lval, &table_base[my_ptr]);
				}
				else
				{ 
					lval[1] = table_base[my_ptr + TYPE];
					lval[2] = 0;
				}

				k = 1;

				continue;
			}

			switch (lval[3])
			{
			  case TABLE_GLOBAL:
				table_base = g_sym_tab;
				break;

			  case TABLE_LOCAL:
				table_base = l_sym_tab;
				break;

			  case TABLE_MACRO:
				table_base = macro_pool;
				break;

			  default:
				break;
			}

			if (match ("("))
			{
				if (my_ptr)
				{
					if (table_base[my_ptr + IDENT] != FUNCTION)
					{
						rvalue(lval);
						callfunction(NULL);
					}
					else
					{
						callfunction(&table_base[my_ptr]);
					}					
				}
				else
				{
					callfunction(NULL);
				}

				k = 0;
				*lval = 0;

				continue;
			}

			return k;
		}
	}

	if (!my_ptr)
	{
		return k;
	}

	if (table_base[my_ptr + IDENT] == FUNCTION)
	{ 
		address(&table_base[my_ptr]);

		return 0;
	}

	return k;
}

short primary(short *lval)
{
	short num = 0;
	short k = 0;
	short my_lptr = 0;
	short save_lptr = 0;
	short ptr = 0;
	char sname[NAMESIZE] = { '\0' };

	if (match("("))
	{ 
		do 
		{
			k = heir1(lval);

		} while (match(","));

		needbrack(")");

		return k;
	}

	lval[2] = 0;

	needst = FALSE;

	my_lptr = lptr;

	if (symname(sname))
	{ 
		ptr = findloc(sname);

		if (ptr)
		{ 
			lval[3] = TABLE_LOCAL;

			if (l_sym_tab[ptr + IDENT] == LABEL)
			{ 
				oocerr();
				return 0;
			}

			getloc(&l_sym_tab[ptr]);

			*lval = ptr;
			lval[1] = l_sym_tab[ptr + TYPE];

			if (isptr(&l_sym_tab[ptr]))
			{
				lval[1] = CINT; 
				setl2(lval, &l_sym_tab[ptr]);
			}

			if (l_sym_tab[ptr + IDENT] == ARRAY)
			{
				setl2(lval, &l_sym_tab[ptr]); 
				return 0;
			}
			else
			{
				return 1;
			}
		}

		ptr = findglb(sname);

		if (ptr)
		{
			lval[3] = TABLE_GLOBAL;

			if (g_sym_tab[ptr + IDENT] != FUNCTION)
			{
				*lval = ptr;
				lval[1] = 0;

				if ((g_sym_tab[ptr + IDENT] != ARRAY) && (g_sym_tab[ptr + IDENT] != PTRAR1))
				{ 
					if (isptr(&g_sym_tab[ptr]))
					{
						setl2(lval, &g_sym_tab[ptr]); 
					}

					return 1;
				}

				address(&g_sym_tab[ptr]);

				lval[1] = setl2(lval, &g_sym_tab[ptr]);

				return 0;
			}
		}

		save_lptr = lptr;
		lptr = my_lptr;

		if (constant(&num))
		{
			*lval = 0;
			lval[1] = 0;

			return 0;
		}

		lptr = save_lptr;

		ptr = addglb(sname, FUNCTION, CINT, 0, 1);

		lval[3] = TABLE_GLOBAL;
		*lval = (short)ptr;
		lval[1] = 0;

		return 0;
	}

	if (constant(&num))
	{
		*lval = 0;
		lval[1] = 0;

		return 0;
	}
	else
	{
		errrpt("Invalid expression.");

		clrp();
		junk();

		return 0;
	}
}

short setl2(short lval [], char pointer [])
{
	lval[2] = pointer[TYPE];

	return lval[2];
}

void step1(short lval [], short up)
{
	updn(lval, up);
	rvalue(lval);

	needst = FALSE;
}

void step2(short lval [], short up)
{
	short my_ptr = 0;
	char* table_base = NULL;
	
	if (lval[1])
	{
		switch (lval[3])
		{
		  case TABLE_GLOBAL:
			table_base = g_sym_tab;
			break;

		  case TABLE_LOCAL:
			table_base = l_sym_tab;
			break;

		  case TABLE_MACRO:
			table_base = macro_pool;
			break;

		  default:
			break;
		}

		my_ptr = *lval;	 

		if (ischar(&table_base[my_ptr]))
		{ 
			ot("MOVB");
			ol((rtext ? "*R8, R9" : "*8, 9"));

			updn(lval, up);

			ot("MOV");
			ol((rtext ? "R9, R8" : "9, 8"));

			ot("SRL");
			ol((rtext ? "R8, R8" : "8, 8"));
		}
		else
		{ 
			ot("MOV");
			ol((rtext ? "*R8, R9" : "*8, 9"));
	
			updn(lval, up);

			ot("MOV");
			ol((rtext ? "R9, R8" : "9, 8"));
		}

		needst = FALSE;
	}
	else
	{ 
		rvalue(lval);
		updn(lval, up);

		needst = TRUE;
	}
}

void updn(short lval [], short up)
{
	short my_ptr = *lval;
	char* table_base = NULL;

	switch (lval[3])
	{
	  case TABLE_GLOBAL:
		table_base = g_sym_tab;
		break;

	  case TABLE_LOCAL:
		table_base = l_sym_tab;
		break;

	  case TABLE_MACRO:
		table_base = macro_pool;
		break;

	  default:
		break;
	}

	if (ischar(&table_base[my_ptr]))
	{ 
		ot("LI");
		ot((rtext ? "R7, >" : "7, >"));

		outl((up ? "0100" : "FF00"));

		ot("AB");
		ot((rtext ? "R7, " : "7, "));

		if (lval[1])
		{ 
			outl((rtext ? "*R8" : "*8"));
		}
		else
		{ 
			outbyte('@'); 
			otlbll(&table_base[my_ptr]);
		}
	}
	else
	{ 
		ot((up ? "INC" : "DEC"));

		if (isword(lval))
		{ 
			outbyte('T');
		} 

		if (lval[1])
		{ 
			ol((rtext ? "*R8" : "*8"));
		} 
		else
		{ 
			ot("@"); 
			otlbll(&table_base[my_ptr]);
		}
	}
}

/* compile &&, || with early dropout
*/
short dolog(char* symb, char* opcode, char* dropop, char* endop, short (*heir)(), short lval [])
{
	short k = 0;
	short hit = 0;
	short droplab = 0;

	for ( ; ; )
	{ 
		k = heir(lval);

		if (match(symb))
		{ 
			if (!hit)
			{ 
				++hit;
				droplab = getlabel();
			}

			droptst(k, opcode, droplab, lval);

			continue;
		}

		if (hit)
		{ 
			droptst(k, opcode, droplab, lval);

			ol (endop);
			ot ("JMP");
			ol ("$ + 4");
			prlbll(droplab);
			ol (dropop);

			needst = FALSE;

			lval[0] = 0;
			lval[1] = 0;
			lval[2] = 0;

			return 0;
		}

		return k;
	}
}

/* test for early dropout from &&, ||
*/
void droptst(short k, char* opcode, short label, short lval [])
{
	if (k)
	{
		rvalue(lval);
	}

	if (needst)
	{
		ot("ABS");
		ol((rtext ? "R8" : "8"));
	}

	ot(opcode);
	ol("$ + 6");
	jump(label);
}

/* compile conditional expression ( ? a : b )
*/
void condexp(void)
{
	short flab1 = getlabel();
	short flab2 = getlabel();

	briff(flab1);

	doexpr();

	jump(flab2);

	prlbll(flab1);
	needbrack(":");

	doexpr();

	prlbll(flab2);
}

void address(char* pointer)
{
	immed();
	outlbl(pointer);

	asmcomment("*   Immediate Value");

	newline();
}

void store(short lval [])
{
	short my_ptr = 0;
	char* table_base = NULL;
	
	if (!lval[1])
	{
		my_ptr = *lval;

		switch (lval[3])
		{
		  case TABLE_GLOBAL:
			table_base = g_sym_tab;
			break;

		  case TABLE_LOCAL:
			table_base = l_sym_tab;
			break;

		  case TABLE_MACRO:
			table_base = macro_pool;
			break;

		  default:
			break;
		}

		putmem(&table_base[my_ptr]);
	}
	else
	{
		putstk(lval[1]);
	}

	needst = FALSE;
}

void rvalue(short lval [])
{
	short my_ptr = 0;
	char* table_base = NULL;
	
	if (!(*lval))
	{
		return;
	}

	if (!lval[1])
	{
		my_ptr = *lval;

		switch (lval[3])
		{
		  case TABLE_GLOBAL:
			table_base = g_sym_tab;
			break;

		  case TABLE_LOCAL:
			table_base = l_sym_tab;
			break;

		  case TABLE_MACRO:
			table_base = macro_pool;
			break;

		  default:
			break;
		}

		getmem(&table_base[my_ptr]);
	}
	else
	{
		indirect(lval[1]);
	}
}

void test(short label, short paren)
{
	if (paren)
	{
		needbrack("(");
	}

	doexpr();

	if (paren)
	{
		needbrack(")");
	}

	briff(label);
}

/* branch to label if primary register is false
*/
void briff(short label)
{
	if (needst)
	{
		ot("ABS");		/*	Generate status	*/
		ol((rtext ? "R8" : "8"));
	}

	ot("JNE");		/*	Skip if r8 true	*/
	ol("$ + 6");	/*	Skip if r8 true	*/

	jump(label);
}

short constant(short *val)
{
	if (hexnum(val))
	{
		outval(val);
	}
	else if (number(val))
	{
		outval(val);
	}
	else if (pstr(val))
	{
		outval(val);
	}
	else if (qstr(val))
	{ 
		immed();
		printlabel(litlab);

		if (*val)
		{
			outbyte('+'); 
			outdec(*val);
		}

		asmcomment("*   Immediate Value");

		newline();
	}
	else
	{
		return FALSE;
	}

	return TRUE;
}

short constx(short* val)
{
	if (hexnum(val))
	{
		;
	}
	else if (number(val))
	{
		;
	}
	else if (pstr(val))
	{
		;
	}
	else
	{ 
		ntcerr();
		*val = 0;

		return FALSE;
	}

	return TRUE;
}

void outval(short* lval)
{
	if (*lval)
	{
		immed();
		outdec(*lval);

		asmcomment("*   Immediate Value");

		newline();
	}
	else
	{
		clrp();
	}
}

short hexnum(short* val)
{
	short c = 0;
	short k = 0;
	short t = 0;

	if (match("0X") || match("0x"))
	{ 
		k = 0;

		for ( ; ; )
		{ 
			c = cur_ch();

			if (numeric(c))
			{
				t = 48;
			}
			else if ((c >= 'A') && (c <= 'F'))
			{
				t = 55;
			}
			else if ((c >= 'a') && (c <= 'f'))
			{
				t = 87;
			}
			else
			{
				break;
			}

			k = (k << 4) + (inbyte() - t);
		}

		*val = k;

		return TRUE;
	}

	return FALSE;
}

short number(short* val)
{
	short k = 0;
	short minus = 0;
	short my_char = 0;
	char mac_name[LINESIZE] = { '\0' };
	char* macro = NULL;

	if (match("-"))
	{
		minus = 1;
	}

	if (!numeric(cur_ch()))
	{
		if (!alpha(cur_ch()))
		{
			return FALSE;
		}

		if (symname(mac_name))
		{
			macro = findmac(mac_name);

			if ((macro == NULL) || (*macro == '\0'))
			{
				return FALSE;
			}

			while (*macro != '\0')
			{
				my_char = ((*macro++) & 0xff);

				if (!numeric(my_char))
				{
					break;
				}

				k = ((k * 10) + (my_char & 0xf));
			}
		}
	}
	else
	{
		while (numeric(cur_ch()))
		{
			k = (((k * 10) + inbyte()) - '0');
		}
	}

	if (minus)
	{
		k = (-k);
	}

	*val = k;

	return TRUE;
}

short pstr(short* val)
{
	short c = 0;
	short k = 0;

	if (!match("'"))
	{
		return FALSE;
	}

	c = litchr();

	while (c != 39)
	{ 
		if (!cur_ch())
		{
			break;
		}

		k = ((k << 8) | c);
		c = litchr();
	}

	*val = k;

	return TRUE;
}

short qstr(short *val)
{
	if (!match(quote))
	{
		return FALSE;
	}

	*val = litptr;

	while (cur_ch() != '"')
	{ 
		if (!cur_ch())
		{
			break;
		}

		stolit(litchr(), CCHAR);
	}

	get_ch();
	stolit(0, CCHAR);

	return TRUE;
}

void stolit(short val, short siz)
{
	if (litptr >= LITMAX)
	{ 
		oflerr();

		return;
	}

	putlit(val, litptr, siz);

	litptr = litptr + siz;
}

/*
** return current literal char & bump lptr
*/
short litchr(void)
{
	short i = 0;
	short c = 0;

	if (cur_ch() != BACKSLASH)
	{
		return get_ch();
	}

	get_ch();

	switch (cur_ch())
	{
	  case 'n' : 
		get_ch(); 
		return(LINEFEED);
		break;

	  case 't' : 
		get_ch(); 
		return(TAB);		/* HT */
		break;

	  case 'b' : 
		get_ch(); 
		return(BACKSPACE);  /* BS */
		break;

	  case 'f' : 
		get_ch(); 
		return(FORMFEED);	/* FF */
		break;

	  case 'r' : 
		get_ch(); 
		return (RETURN);	/* CR */
		break;
	}

	i = 4; 
	c = 0;

	while ((--i) && (cur_ch() >= '0') && (cur_ch() < '8'))
	{
		c = (((c << 3) + get_ch()) - '0');
	}

	return ((i == 3) ? get_ch() : c);
}

/* */
/* Begin a comment line for the assembler */
void comment(void)
{
	outbyte(STAR);
}

/* Output assembler info before any code is generated
*/
void header(void)
{
	outl(logo);
	ol("REF  C$CIND,C$DIV,C$REM,C$ASR,C$ASL,C$EQ,C$NE");
	ol("REF  C$LT,C$LE,C$GT,C$GE,C$ULT,C$ULE,C$UGT,C$UGE");
	ol("REF  C$LNEG,C$SWCH,GETCHA,GETS,PUTCHA,PUTS,LOCATE");
	ol("REF  POLL,TSCRN,EXIT,C$CALL");
}

/* Output END directive after all code
*/
void trailer(void)
{
	ol("END");
}

/* output DATA directive
*/
void ddata(void)
{
	ot("DATA");
	tab();
}

/* fetch a static memory cell into the primary register
*/
void getmem(char* sym)
{
	if (ischar(sym))
	{ 
		ot("CLR");
		ol((rtext ? "R8" : "8"));

		ot("MOVB");
		ot("@");
		outlbl(sym);

		outl((rtext ? ", *R10" : ", *10"));
	}
	else
	{ 
		ot("MOV");
		ot("@");
		outlbl(sym);

		outl((rtext ? ", R8" : ", 8"));
	}
}

/* Fetch the address of the specified symbol
** into the primary register
*/
void getloc(char* sym)
{
	short k = getint(sym + OFFSET) - stkp;

	ot("MOV");
	ol((rtext ? "R14, R8" : "14, 8"));

	asmcomment("*   Get Address of Symbol to (Step 1)");

	newline();

	if (k)
	{ 
		if (k == 2)
		{ 
			ot("INCT");
			ot((rtext ? "R8" : "8"));

			asmcomment("*   Get Address of Symbol (Step 2)");
		} 
		else
		{ 
			ot("AI"); 
			ot((rtext ? "R8, " : "8, "));
			outdec(k); 

			asmcomment("*   Get Address of Symbol (Step 2)");
		}
	}

	newline();
}

/* putmem and putstk must not alter the primary register
*/
/* Store the primary register into the specified
** static memory cell
*/
void putmem(char* sym)
{
	if (ischar(sym))
	{
		ot("MOVB");
		ot((rtext ? "*R10, @" : "*10, @"));
	}
	else
	{
		ot("MOV");
		ot((rtext ? "R8, @" : "8, @"));
	}

	otlbll(sym);
}

/* Store the specified object type in the primary register
** at the address on the top of the stack
*/
void putstk(short typeobj)
{
	pop();

	ot("MOV");
	ol((rtext ? "*R14+, R9" : "*14+, 9"));

	if (typeobj == CCHAR)
	{
		ot("MOVB");
		ol((rtext ? "*R10, *R9" : "*10, *9"));
	}
	else
	{
		ot("MOV");
		ol((rtext ? "R8, *R9" : "8, *9"));
	}
}

/* Fetch the specified object type indirect through the */
/* primary register into the primary register */
void indirect(short typeobj)
{
	if (typeobj == CCHAR)
	{
		ot("MOVB");
		ol((rtext ? "*R8, R8" : "*8, 8"));

		ot("SRL");
		ol((rtext ? "R8, R8" : "8, 8"));
	}
	else
	{
		ot("MOV");
		ol((rtext ? "*R8, R8" : "*8, 8"));
	}
}

/* Print partial instruction to load immediate */
/* into the primary register */
void immed(void)
{
	ot("LI");
	ot((rtext ? "R8, " : "8, "));
}

/* Push the primary register onto the stack */
void push(void)
{
	if (pushin)
	{
		ot("DECT");
		ot((rtext ? "R14" : "14"));

		asmcomment("*   Stack Push (Part 1)");

		newline();

		ot("MOV");
		ot((rtext ? "R8, *R14" : "8, *14"));

		asmcomment("*   Stack Push (Part 2)");
	}
	else
	{
		ot("BL");
		ot((rtext ? "R15" : "15"));

		asmcomment("*   Stack Push");
	}

	newline();

	stkp -= 2;
}

/* Alter stack pointer for pop operation */
void pop(void)
{
	stkp += 2;
}

/* Return from subroutine */
void ret(void)
{
	ot("B");
	ot((rtext ? "*R13" : "*13"));

	asmcomment("*   Return From Subroutine");

	newline();
}

/* Direct call to compiler subroutine */
void dcall(char* sname)
{
	ot("BL"); 
	ot("@C$"); 
	outstr(sname);

	asmcomment("*   Direct Call To Subroutine");

	newline();

	needst = FALSE;
}

/* Jump to specified internal label number */
void jump(short label)
{
	char buffer[81] = { '\0' };

	ot("B");
	ot("@");
	printlabel(label);

	sprintf(buffer, "*   Jump to C$%d", label);
	asmcomment(buffer);

	newline();
}

/* Modify the stack pointer to the new value indicated */
short modstk(short newsp)
{
	short k = 0;
	char* regstr = rtext ? "R14, " : "14, ";

	if ((newsp & 1) != 0)  /*ensure word boundary*/
	{
		if (newsp > 0)
		{
			newsp++;
		}
		else
		{
			newsp--;
		}
	}

	k = newsp - stkp;

	if (!k)
	{
		return newsp;
	}

	if (k == 2)
	{ 
		ot("INCT");
		ot(regstr);

		newline();

		return newsp;
	}

	if (k == -2)
	{ 
		ot("DECT");
		ot(regstr);

		newline();

		return newsp;
	}

	ot("AI");
	ot(regstr);

	outdcl(k);

	return newsp;
}

/* Double the primary register */
void doublereg(void)
{
	ot("A");
	ot((rtext ? "R8, R8" : "8, 8"));

	asmcomment("*   Left-Shift (Double) Primary Register");

	newline();
}

/* Add stack top to primary register */
void add(void)
{
	ot("A");
	ot((rtext ? "*R14+, R8" : "*14+, 8"));

	asmcomment("*   Add Top-of-Stack to Primary Register");

	newline();

	needst = FALSE;
}

/* Clear primary reg */
void clrp(void)
{
	ot("S");
	ot((rtext ? "R8, R8" : "8, 8"));

	asmcomment("*   clear primary register");

	newline();
}
/* <<<<<  End of compiler  >>>>> */