/* C99CSB - c99 compiler subroutines
**
** (c) 1987 by Clint Pulley
**
** Last Edit 87/03/05  2300
** Edit # ???  : 28-Dec-99  0100  (Kristine Rogers)
*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <process.h>

#pragma inline_depth (250)

#include "myfuncs.h"
#include <stdlib.h>

#include "c99.h"

/*
** get filename and open file
*/
short getfn(short inp, char* fn, char *m)
{
	short unit = 0;

	unix2dos_path(fn);

	if (*fn != '\0')
	{
		unit = FOPEN(fn, m);
	}

	if (unit == 0)
	{
		PUTS(inp ? "Input" : "Output");
		PUTS(" filename is invalid.  Using ");
		PUTS(inp ? "stdin" : "stdout");
		PUTS(" instead.\n");
	}

	return unit;
}

short getlit(short litptr, short type)
{
	short val = 0;
	char out_string[81] = { '\0' };

	if ((type == CCHAR) || (type == CINT))
	{
		val = lit_pool[litptr];
		return val;
	}

	sprintf(out_string, "getlit: Unknown type \"%d\"!", type);
	errrpt(out_string);
	exit(1);
}

void putlit(short val, short litptr, short size)
{
	char out_string[81] = { '\0' };

	if ((size == CCHAR) || (size == CINT))
	{
		lit_pool[litptr] = val;

		return;
	}

	sprintf(out_string, "putlit: Unknown size \"%d\"!", size);
	errrpt(out_string);
	exit(1);
}

short hash(char *sname)
{
	short index = 0;
	short hash_value = 0;

	while (sname[index] != '\0')
	{
		hash_value += (((short)sname[index]) & 0xff);
		index++;
	}

	hash_value &= 0xff;

	if (hash_value == 0)
	{
		hash_value++;
	}

	return hash_value;
}

short alpha(short c)
{
	if (!isalpha(c))
	{
		if (c != '_')
		{
			return 0;
		}
	}

	return c;
}

short alnum(short c)
{
	if (!isalnum(c))
	{
		if (c != '_')
		{
			return 0;
		}
	}

	return c;
}

short numeric(short c)
{
	if (!isdigit(c))
	{
		return 0;
	}

	return c;
}

short getint(char *addr)
{
	return ((((short)*addr++) & 0xff) | ((((short)*addr) << 8) & 0xff00));
}

void putint(short i, char *addr)
{
	*addr++ = (char)(i & 0xff);
	*addr = (char)((i >> 8) & 0xff);
}

short streq(char *str)
{
	short line_index = lptr;
	short str_index = 0;

	while (str[str_index] == line[line_index])
	{
		if (str[str_index] == '\0')
		{
			break;
		}

		line_index++;
		str_index++;
	}

	if (str[str_index] == '\0')
	{
		return str_index;
	}

	return 0;
}

short astreq(char str1 [], char str2 [], short len)
{
	short count = 0;

	for (count = 0; count < len; count++)
	{
		if (str1[count] != str2[count])
		{
			break;
		}

		if (str1[count] == '\0')
		{
			break;
		}

		if (str2[count] == '\0')
		{
			break;
		}
	}

	if (isalnum(str1[count]) || (str1[count] == '_'))
	{
		return 0;
	}

	if (isalnum(str2[count]) || (str2[count] == '_'))
	{
		return 0;
	}

	return count;
}

short cfread(char *str1, short unit)
{
	short index = 0;

	if (unit <= 0)
	{
		tigets(str1, LINEMAX);
		return 1;
	}

	if (file_table[unit] == NULL)
	{
		return 0;
	}

	if (fgets(str1, LINEMAX, file_table[unit]) == NULL)
	{
		return -1;
	}

	index = (short)strlen(str1);

	while (index > 0)
	{
		if (!iscntrl(str1[index - 1]))
		{
			break;
		}

		str1[index - 1] = '\0';
		index--;
	}

	return 1;
}

short tiputchar(short c)
{
	return ((short)putc(c, stderr));
}

short tiputc(short c, short unit)
{
	short status = 0;

	if (unit == 0)
	{
		return ((short)putc(c, stdout)); 
	}

	if (file_table [unit] == NULL)
	{
		return 0;
	}

	status = (short)fputc(c, file_table[unit]);

	if (c == '\n')
	{
		fflush(file_table[unit]);
	}

	return status;
}

short tiputs(char *str)
{
	short status = (short)fputs(str, stderr);

	if (status == EOF)
	{
		return 0;
	}

	return status;
}

short tigets(char *str, short max)
{
	short status = 0;

	if (!fgets(str, max, stdin))
	{
		return 0;
	}

	status = (short)strlen(str);

	while (status > 0)
	{
		if (!iscntrl(str[status - 1]))
		{
			break;
		}

		str[status - 1] = '\0';
		status--;
	}

	return status;
}

short tifopen(char *name, char *mode)
{
	short index = 1;
	char fullname[LINESIZE] = { '\0' };

	/*	Find an unused entry.	*/
	while (file_table[index])
	{
		index++;

		if (index > 4)
		{
			return 0;
		}
	}

	str_tolower(name);
	unix2dos_path(name);

	file_table[index] = fopen(name, mode);

	if (!file_table[index] && (base_dir[0] != '\0') && (strncmp(name, base_dir, strlen(base_dir)) != 0))
	{
		sprintf(fullname, "%s/%s", base_dir, name);

		str_tolower(fullname);
		unix2dos_path(fullname);

		file_table[index] = fopen(fullname, mode);
	}

	if (file_table[index])
	{
		return index;
	}

	return 0;
}

short tifclose(short unit)
{

	if (!file_table[unit])
	{
		return 0;
	}

	fflush(file_table[unit]);
	fclose(file_table[unit]);
	file_table[unit] = NULL;

	return 0;
}